\section{Figures}
	Figures.
	
	\begin{figure}[h]
		\centering
		\includegraphics[width=1\linewidth]{img/placeholder.png}
		\caption[Network systems building blocks.]{Distributed Systems and their consensus algorithms exist since decades; Consortium Networks adopt a weak form of internal political decentralization and often revised well known consensus algorithms, started to be popular used after the advent of Blockchain protocols; Still not mature Blockchain protocols use a innovative class of consensus algorithms which comprehends elements of Game Theory and opens to the public.}
		\label{fig:dec}
	\end{figure}

	\begin{figure}[h]
		\vspace{0.7ex}
		\begin{subfigure}[]{\columnwidth}
			\caption{Ethereum transactions per day processed.}
			\vspace{-1ex}
			\includegraphics[width=\textwidth]{placeholder}
			\label{subfig:txperday}
		\end{subfigure}
		
		\vspace{0.7ex}
		\begin{subfigure}[]{\columnwidth}
			\caption{Ethereum average transaction fee expressed in \texttt{USD}.}
			\vspace{-1ex}
			\includegraphics[width=\textwidth]{placeholder}
			\label{subfig:avgfee}
		\end{subfigure}
		
		\vspace{-1ex}
		\caption[Ethereum workload in January 2018]{Ethereum Protocol workload in January 2018 (Source\footnotemark): transaction fees (\ref{subfig:avgfee}) tend to rise up unredictably at a growing number of transactions yet to be processed by miners (\ref{subfig:txperday}).}
		\label{fig:scalability}
	\end{figure}
	\footnotetext{\url{https://bitinfocharts.com}}
	
	\begin{figure*}[h!]
		\includegraphics[width=\textwidth]{img/placeholder.png}
		\caption[Data-Pointer type Model of Storage]{Example of a Decentralized Data-Pointer storage schema.}
		\label{fig:data-schema}
	\end{figure*}

	% [FIX] logical decentralization https://medium.com/@VitalikButerin/the-meaning-of-decentralization-a0c92b76a274
	\begin{figure}[h]
		\begin{center}
			\resizebox{\columnwidth}{!}{%
				\begin{tikzpicture}
					\node[fill=black, draw=black, scale = 0.5, rectangle](n1) {};
					\node[fill=black, draw=black, scale = 0.5, rectangle, right = 1cm of n1](n2) {};
					\node[fill=black, draw=black, scale = 0.5, rectangle, right = 1cm of n2](n3) {};
					\node[fill=black, draw=black, scale = 0.5, rectangle, right = 1cm of n3](n4) {};
					\node[fill=black, draw=black, scale = 0.5, rectangle, right = 1cm of n4](n5) {};
					
					\node[fill=white, draw=black, scale = 0.5, rectangle, above right = .25 and 1cm of n5](a1) {};
					\node[fill=white, draw=black, scale = 0.5, rectangle, right = 1cm of a1](a2) {};
					
					\node[fill=gray, draw=black, scale = 0.5, rectangle, right = 1cm of n5](m0) {};
					\node[fill=gray, draw=black, scale = 0.5, rectangle, right = 1cm of m0](m1) {};
					\node[fill=white, draw=black, scale = 0.5, rectangle, right = 1cm of m1](m2) {};
					
					\node[fill=white, draw=black, scale = 0.5, rectangle, below right = 0.25cm and 1cm of m0](b0) {};
					
					\draw (n1) to (n2);
					\draw (n2) to (n3);
					\draw (n3) to (n4);
					\draw (n4) to (n5);
					\draw (n5) to (m0);
					
					\draw (a1) to (a2);
					
					\draw (m0) to (m1);
					\draw (m1) to (m2);
					
					\draw (n5) to[out=0,in=180] (a1);
					\draw (n5) to[out=0,in=180] (a1);
					\draw (m0) to[out=0,in=180] (b0);
					
					\draw[tuborg] let \p1=(m2.east), \p2=(n5.west) in ($(\x1,\y1-.6cm)$) -- ($(\x2,\y2-.6cm)$) node[below = 0.1cm, midway] {$k<T$ rounds};
				\end{tikzpicture}
			}
		\end{center}
		\caption[A Blockchain protocol relaxed form of consistency.]{Blockchain version of data consistency. At any given point in time nodes don't exactly agree about the transaction sequence, but they will very highly likely agree sooner than the next $T$ rounds.}
		\label{fig:bc-consistency}
	\end{figure}

	\begin{figure}[h]
		\begin{center}
			\resizebox{\columnwidth}{!}{%
				\begin{tikzpicture}
					\node[stackwhiterectangle] at (1.7,0) (smartcontracts) {Smartcontracts \\ \textbf{Logic, Relations, Tokens}};
					\node[stackblackrectangle, below = .1cm of smartcontracts] (ledger) {Transaction Ledger \\ \textbf{Native Assets}};
					\node[stackblackrectangle, below = .1cm of ledger] (algorithm) {Consensus Algorithm \\ \textbf{Governance}};
					\node[stackblackrectangle, below = .1cm of algorithm] (p2p) {Peer-to-Peer Architercture \\ \textbf{Network}};
					\node[stackwhiterectangle, below = .1cm of p2p] (tcpip) {TCP/IP};
					
					\draw[tuborg] let \p1=(ledger.north), \p2=(p2p.south) in ($(\x1+2.3cm,\y1)$) -- ($(\x2+2.3cm,\y2)$) node[right = .1cm of smartcontracts, right, midway] {\textbf{Blockchain Layer}};
					\draw[tuborg] let \p1=(tcpip.north), \p2=(tcpip.south) in ($(\x1+2.3cm,\y1)$) -- ($(\x2+2.3cm,\y2)$) node[right = .1cm of smartcontracts, right, midway] {\textbf{Internet Layer}};
					\draw[tuborg] let \p1=(smartcontracts.north), \p2=(smartcontracts.south) in ($(\x1+2.3cm,\y1)$) -- ($(\x2+2.3cm,\y2)$) node[right = .1cm of smartcontracts, text width=4cm, right, midway] {\textbf{Decentralized Appplication Layer}};
				\end{tikzpicture}
			}
		\end{center}
		\caption[Blockchain and Smart Contract Tech-Stack.]{Abstracted Blockchain and Smart Contract Technology Stack.}
		\label{fig:bsstack}
	\end{figure}

	\begin{figure}[h]
		\begin{center}
			\begin{tikzpicture}
				\node[dapprectangle] (front) {Front End\\(HTML, CSS)};
				\node[dappblackrectangle, below = .1cm of front] (back) {Back End\\(JavaScript)};
				\node[dappblackrectangle, below = .1cm of back] (logic) {Decentralized Logic\\Smartcontracts\\(LLL, Solidity, Serpent)};
			\end{tikzpicture}
		\end{center}
		\caption[Decentralized Application Architecture.]{Abstracted Decentralized Application Architecture.}
		\label{fig:dapp}
	\end{figure}

	\begin{table}[h]
		\centering
		\begin{tabular}{c|c}
			Blockchain                                                          & Consortium                                                                \\ \hline
			public                                                              & regulated access                                                          \\ \hline
			no fixed costs                                                      & no transaction fees                                                       \\ \hline
			\begin{tabular}[c]{@{}c@{}}strong\\ decentralization\end{tabular}   & \begin{tabular}[c]{@{}c@{}}loose internal\\ decentralization\end{tabular} \\ \hline
			\begin{tabular}[c]{@{}c@{}}data validated\\ world-wide\end{tabular} & \begin{tabular}[c]{@{}c@{}}near-instant\\ transactions\end{tabular}       \\ \hline
			immutable                                                           & modifiable records                                                       
		\end{tabular}
		\caption[Blockchain and Consortium Comparison.]{Blockchain and Consortium Comparison}
		\label{tab:bc-vs-c}
	\end{table}

	\begin{table}[ht]
		\centering
		\begin{tabular}{|c|r|l|r|l|}
			\multicolumn{1}{|c|}{\multirow{2}{*}{\begin{tabular}[c]{@{}c@{}}gas price\end{tabular}}} & \multicolumn{2}{c|}{test-net (ropsten)} & \multicolumn{2}{c|}{main-net} \\
			\multicolumn{1}{|c|}{} & \multicolumn{1}{c|}{time} & \begin{tabular}[c]{@{}c@{}}\texttt{txFee}\end{tabular} & \multicolumn{1}{c|}{time} & \multicolumn{1}{l|}{\begin{tabular}[c]{@{}c@{}}\texttt{txFee}\end{tabular}} \\ \hline
			\multirow{2}{*}{4 \texttt{Gwei}} & \multirow{2}{*}{$45s$} & \texttt{EUR} 1.21 & \multirow{2}{*}{$480s$} & \texttt{EUR} 1.26 \\
			& & \texttt{ETH} 0.00134 & & \texttt{ETH} 0.00140 \\ \hline
			\multirow{2}{*}{9 \texttt{Gwei}} & \multirow{2}{*}{$39s$} & \texttt{EUR} 2.71 & \multirow{2}{*}{$1080s$} & \texttt{EUR} 2.71 \\
			& & \texttt{ETH} 0.00302 & & \texttt{ETH} 0.00302  \\ \hline
			\multirow{2}{*}{20 \texttt{Gwei}} & \multirow{2}{*}{$33s$} & \texttt{EUR} 6.64 & \multirow{2}{*}{$90s$} & \texttt{EUR} 6.039 \\
			& & \texttt{ETH} 0.00738 & & \texttt{ETH} 0.00671 \\ \hline
			\multirow{2}{*}{40 \texttt{Gwei}} & \multirow{2}{*}{$42s$} & \texttt{EUR} 12.09 & \multirow{2}{*}{$17s$} & \texttt{EUR} 12.09 \\
			& & \texttt{ETH} 0.01343 & & \texttt{ETH} 0.01343
		\end{tabular}
		\caption[Fees and confirmation time at different gas price values.]{Transaction fees and required confirmation time at different gas price values. \texttt{gasLimit} is fixed, determined by computational complexity which is static and not visualized. \texttt{1 ETH} exchange rate is fixed at the price of \texttt{EUR} 900 back in January 2018.}
		\label{tab:cost}
	\end{table}

	\begin{figure}
		\begin{center}
			\resizebox{\columnwidth}{!}{
				\begin{tikzpicture}
					\draw (0,0) node[anchor=north]{\large ($C$) \textbf{Consensus}}
					(0,0.2) node[anchor=north]{}
					[line width=0.7mm, black] -- (8,0.2) node[anchor=north]{}
					(8,0) node[anchor=north]{\large ($D$) \textbf{Decentralization}}
					(8,0.2) node[anchor=north]{}
					-- (4,5.8) node[anchor=south]{}
					(4,6) node[anchor=south]{\large ($S$) \textbf{Scale}}
					(4,5.8) node[anchor=south]{}
					-- (0,0.2) node[anchor=north]{}
					(4,1)node[anchor=north]{\Large \textsc{Ethereum} [DC]};
				\end{tikzpicture}
			}
		\end{center}
		\caption[The Blockchain Trilemma: DCS Triangle]{The DCS Triangle: only two out of the three mentioned properties can be \textit{easily} achieved.}
		\label{fig:dcstriangle}
	\end{figure}

	\begin{trilemma}[DCS Theorem]\label{theorem:dcs} 
		A Blockchain protocol can have at most two out of the three properties of decentralization, scale and consensus. Where:
		\begin{enumerate}
			\item \textbf{decentralization}, guarantees that the system has no architectural single point of failure nor political single point of decision;
			\item \textbf{consensus} (or consistency, guarateed by the consensus), network participants share the same system state, reached by consensus algorithms such as Proof of Work;
			\item \textbf{scale}, defines the capability of the system to handle a growing workload demand.
		\end{enumerate}
	\end{trilemma}

	\begin{table}[h]
		\centering
		\resizebox{\columnwidth}{!}{%
			\begin{tabular}{r|l}
				\texttt{ERC-20} & \texttt{ERC-865} \\
				\texttt{transfer} & \texttt{transferPreSigned} \\
				\texttt{approve} & \texttt{approvePreSigned} \\
				& \texttt{increase/decreaseApprovalPreSigned} \\
				\texttt{transferFrom} & \texttt{transferFromPreSigned}
			\end{tabular}%
		}
		\caption[\texttt{ERC-865} interface similarities]{\texttt{ERC-865} shares the same basic principles of an \texttt{ERC-20} token, except that transactions are presigned by someone different from the author.}
		\label{tab:ierc865}
	\end{table}

	\hl{Highlighted text.}
	
	{\color{red}\textbf{Colored Text}}
	
	\begin{itemize}
		\item[$\checkmark$] text;
		\item[$\checkmark$] text;
	\end{itemize}

	\lstset{
		basicstyle=\BeraMonottfamily,
		frame=lrtb
	}
	\begin{figure}[h!]
		\label{code:portis}
		\lstinputlisting[language=JavaScript, frame=none, numbers=right,
		caption={Portis Provider Setup}]{sample.js}
		\caption[Portis provider setup]{Creating a new dapp with portis and setting up a custom provider.}
	\end{figure}
	
